]> git.ipfire.org Git - ipfire-2.x.git/blob - make.sh
Bootscripte an den IPFire angepasst.
[ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2006 IPFire-Team <info@ipfire.eu>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.0b" # Version number
28 SLOGAN="www.ipfire.org" # Software slogan
29 CONFIG_ROOT=/var/ipfire # Configuration rootdir
30 NICE=10 # Nice level
31 MAX_RETRIES=1 # prefetch/check loop
32 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33 MACHINE=`uname -m`
34 SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
36 IPFVER="full" # Which version should be compiled? (full|light|voice)
37
38 # Set an information about the build number
39 if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41 fi
42
43 # Debian specific settings
44 if [ ! -e /etc/debian_version ]; then
45 FULLPATH=`which $0`
46 else
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
53 fi
54
55 PWD=`pwd`
56 BASENAME=`basename $0`
57 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58 LOGFILE=$BASEDIR/log/_build.preparation.log
59 export BASEDIR LOGFILE
60 DIR_CHK=$BASEDIR/cache/check
61 mkdir $BASEDIR/log/ 2>/dev/null
62
63 # Include funtions
64 . tools/make-functions
65
66 if [ -f .config ]; then
67 . .config
68 else
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
76 fi
77
78 prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
111 else
112 beautify message DONE
113 fi
114
115
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
122 if [ `id -u` != 0 ]; then
123 beautify message FAIL
124 exiterror "Not building as root"
125 else
126 beautify message DONE
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
138 if (( 2048000 > $BASE_ASPACE )); then
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
144 else
145 beautify message DONE
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
173 MAKETUNING="-j12"
174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
185
186 # Make all sources and proc available under lfs build
187 mount --bind /dev $BASEDIR/build/dev
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
202 # This is a temporary hack!!!
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
206
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213 }
214
215 buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
227 lfsmake1 cleanup-toolchain PASS=1
228 lfsmake1 tcl
229 lfsmake1 expect
230 lfsmake1 dejagnu
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
233 lfsmake1 ncurses
234 lfsmake1 bash
235 lfsmake1 bzip2
236 lfsmake1 coreutils
237 lfsmake1 diffutils
238 lfsmake1 findutils
239 lfsmake1 gawk
240 lfsmake1 gettext
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
245 lfsmake1 patch
246 lfsmake1 perl
247 lfsmake1 sed
248 lfsmake1 tar
249 lfsmake1 texinfo
250 lfsmake1 util-linux
251 lfsmake1 cleanup-toolchain PASS=2
252 export PATH=$ORG_PATH
253 }
254
255 buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
258 lfsmake2 stage2
259 lfsmake2 linux-libc-header
260 lfsmake2 man-pages
261 lfsmake2 glibc
262 lfsmake2 cleanup-toolchain PASS=3
263 lfsmake2 binutils
264 lfsmake2 gcc
265 lfsmake2 berkeley
266 lfsmake2 coreutils
267 lfsmake2 iana-etc
268 lfsmake2 m4
269 lfsmake2 bison
270 lfsmake2 ncurses
271 lfsmake2 procps
272 lfsmake2 sed
273 lfsmake2 libtool
274 lfsmake2 perl
275 lfsmake2 readline
276 lfsmake2 zlib
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
280 lfsmake2 bzip2
281 lfsmake2 diffutils
282 lfsmake2 e2fsprogs
283 lfsmake2 ed
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
287 lfsmake2 grub
288 lfsmake2 gawk
289 lfsmake2 gettext
290 lfsmake2 grep
291 lfsmake2 groff
292 lfsmake2 gzip
293 lfsmake2 inetutils
294 lfsmake2 iproute2
295 lfsmake2 kbd
296 lfsmake2 less
297 lfsmake2 make
298 lfsmake2 man
299 lfsmake2 mktemp
300 lfsmake2 modutils
301 lfsmake2 net-tools
302 lfsmake2 patch
303 lfsmake2 psmisc
304 lfsmake2 shadow
305 lfsmake2 sysklogd
306 lfsmake2 sysvinit
307 lfsmake2 tar
308 lfsmake2 texinfo
309 lfsmake2 udev
310 lfsmake2 util-linux
311 lfsmake2 vim
312 }
313
314 buildipfire() {
315 LOGFILE="$BASEDIR/log/_build.ipfire.log"
316 export LOGFILE
317 ipfiremake configroot
318 ipfiremake dhcp
319 ipfiremake dhcpcd
320 ipfiremake libusb
321 ipfiremake libpcap
322 ipfiremake linux-atm
323 ipfiremake ppp
324 ipfiremake rp-pppoe
325 ipfiremake unzip
326 ipfiremake linux SMP=1
327 ipfiremake ipp2p SMP=1
328 # ipfiremake 3cp4218 SMP=1
329 # ipfiremake amedyn SMP=1
330 # ipfiremake cxacru SMP=1
331 # ipfiremake eagle SMP=1
332 # ipfiremake cnx_pci SMP=1
333 # ipfiremake fcdsl SMP=1
334 # ipfiremake fcdsl2 SMP=1
335 # ipfiremake fcdslsl SMP=1
336 # ipfiremake fcdslusb SMP=1
337 # ipfiremake fcdslslusb SMP=1
338 # ipfiremake fcpci SMP=1
339 # ipfiremake fcclassic SMP=1
340 # ipfiremake pulsar SMP=1
341 # ipfiremake unicorn SMP=1
342 # ipfiremake promise-sata-300-tx SMP=1
343 ipfiremake zaptel PASS=S
344 ipfiremake linux
345 ipfiremake ipp2p
346 # ipfiremake 3cp4218
347 # ipfiremake amedyn
348 # ipfiremake cxacru
349 # ipfiremake eciadsl
350 # ipfiremake eagle
351 # ipfiremake speedtouch
352 # ipfiremake cnx_pci
353 # ipfiremake fcdsl
354 # ipfiremake fcdsl2
355 # ipfiremake fcdslsl
356 # ipfiremake fcdslusb
357 # ipfiremake fcdslslusb
358 # ipfiremake fcpci
359 # ipfiremake fcclassic
360 # ipfiremake pulsar
361 # ipfiremake unicorn
362 # ipfiremake promise-sata-300-tx
363 ipfiremake zaptel
364 ipfiremake expat
365 ipfiremake gdbm
366 ipfiremake gmp
367 ipfiremake pam
368 ipfiremake openssl
369 ipfiremake python
370 ipfiremake libnet
371 ipfiremake libjpeg
372 ipfiremake libpng
373 ipfiremake libtiff
374 ipfiremake lcms
375 ipfiremake libmng
376 ipfiremake freetype
377 ipfiremake libart
378 ipfiremake gd
379 ipfiremake popt
380 ipfiremake pcre
381 ipfiremake slang
382 ipfiremake newt
383 ipfiremake libcap
384 ipfiremake pciutils
385 ipfiremake libxml2
386 ipfiremake BerkeleyDB
387 ipfiremake mysql
388 ipfiremake cyrus-sasl
389 ipfiremake openldap
390 ipfiremake apache2
391 ipfiremake php
392 ipfiremake subversion
393 ipfiremake apache2 PASS=C
394 ipfiremake arping
395 ipfiremake beep
396 ipfiremake bind
397 ipfiremake capi4k-utils
398 ipfiremake cdrtools
399 ipfiremake dnsmasq
400 ipfiremake dosfstools
401 ipfiremake reiserfsprogs
402 ipfiremake ethtool
403 ipfiremake ez-ipupdate
404 ipfiremake fcron
405 ipfiremake GD
406 ipfiremake gnupg
407 ipfiremake hdparm
408 ipfiremake ibod
409 ipfiremake initscripts
410 ipfiremake iptables
411 ipfiremake ipp2p IPT=1
412 ipfiremake ipac-ng
413 ipfiremake ipaddr
414 ipfiremake iptstate
415 ipfiremake iputils
416 ipfiremake l7-protocols
417 ipfiremake isapnptools
418 # ipfiremake isdn4k-utils # What about mISDN???
419 ipfiremake kudzu
420 ipfiremake logrotate
421 ipfiremake logwatch
422 ipfiremake mingetty
423 ipfiremake misc-progs
424 ipfiremake mtools
425 ipfiremake nano
426 ipfiremake nash
427 ipfiremake nasm
428 ipfiremake URI
429 ipfiremake HTML-Tagset
430 ipfiremake HTML-Parser
431 ipfiremake Compress-Zlib
432 ipfiremake Digest
433 ipfiremake Digest-SHA1
434 ipfiremake Digest-HMAC
435 ipfiremake libwww-perl
436 ipfiremake Net-DNS
437 ipfiremake Net-IPv4Addr
438 ipfiremake Net_SSLeay
439 ipfiremake IO-Stringy
440 ipfiremake Unix-Syslog
441 ipfiremake Mail-Tools
442 ipfiremake MIME-Tools
443 ipfiremake Net-Server
444 ipfiremake Convert-TNEF
445 ipfiremake Convert-UUlib
446 ipfiremake Archive-Tar
447 ipfiremake Archive-Zip
448 ipfiremake Text-Tabs+Wrap
449 ipfiremake Locale-Country
450 ipfiremake GeoIP
451 ipfiremake fwhits
452 ipfiremake noip_updater
453 ipfiremake ntp
454 ipfiremake oinkmaster
455 ipfiremake openssh
456 ipfiremake openswan
457 ipfiremake pptpclient
458 ipfiremake rrdtool
459 ipfiremake setserial
460 ipfiremake setup
461 ipfiremake snort
462 ipfiremake squid
463 ipfiremake squid-graph
464 ipfiremake squidguard
465 # ipfiremake tcpdump
466 ipfiremake traceroute
467 ipfiremake vlan
468 ipfiremake wireless
469 ipfiremake libsafe
470 ipfiremake 3c5x9setup
471 ipfiremake pakfire
472 ipfiremake startscripts
473 ipfiremake java
474 ipfiremake bootsplash
475 ipfiremake spandsp
476 ipfiremake lzo
477 ipfiremake openvpn
478 ipfiremake pkg-config
479 ipfiremake glib
480 ipfiremake pammysql
481 ipfiremake xinetd
482 ipfiremake ghostscript
483 ipfiremake cups
484 ipfiremake samba
485 ipfiremake sudo
486 ipfiremake mc
487 ipfiremake wget
488 ipfiremake wput
489 ipfiremake bridge-utils
490 ipfiremake screen
491 ipfiremake hddtemp
492 ipfiremake smartmontools
493 ipfiremake htop
494 ipfiremake lynx
495 ipfiremake postfix
496 ipfiremake procmail
497 ipfiremake fetchmail
498 ipfiremake cyrusimap
499 ipfiremake webcyradm
500 ipfiremake mailx
501 ipfiremake clamav
502 ipfiremake razor
503 ipfiremake spamassassin
504 ipfiremake amavisd
505 ipfiremake stund
506 ipfiremake libpri
507 # ipfiremake bristuff
508 ipfiremake asterisk
509 ipfiremake mpg123
510 ipfiremake libmad
511 ipfiremake libogg
512 ipfiremake libvorbis
513 ipfiremake lame
514 ipfiremake xvid
515 ipfiremake mpeg2dec
516 ipfiremake ffmpeg
517 ipfiremake sox
518 ipfiremake gnump3d
519 ipfiremake videolan
520 ipfiremake applejuice
521 ipfiremake ocaml
522 ipfiremake mldonkey
523 ipfiremake ntop
524 ipfiremake rsync
525 ipfiremake tcpwrapper
526 ipfiremake portmap
527 ipfiremake nfs
528 ipfiremake nmap
529 ipfiremake mbmon
530 ipfiremake iftop
531 ipfiremake ncftp
532 ipfiremake cftp
533 ipfiremake etherwake
534 ipfiremake ethereal
535 ipfiremake tftp-hpa
536 ipfiremake iptraf
537 ipfiremake nagios
538 ipfiremake yasuc
539 }
540
541 buildinstaller() {
542 # Run installer scripts one by one
543 LOGFILE="$BASEDIR/log/_build.installer.log"
544 export LOGFILE
545 ipfiremake syslinux
546 ipfiremake memtest
547 installmake linux-libc-header
548 installmake binutils
549 ipfiremake uClibc PASS=1
550 ipfiremake gcc INST=1
551 installmake uClibc PASS=2
552 installmake gcc INST=2
553 installmake uClibc PASS=3
554 installmake busybox
555 installmake udev
556 installmake slang
557 installmake newt
558 installmake gettext
559 installmake kbd
560 installmake popt
561 installmake sysvinit
562 installmake misc-progs
563 installmake e2fsprogs
564 installmake reiserfsprogs
565 installmake sysfsutils
566 installmake util-linux
567 installmake pciutils
568 installmake kudzu
569 # installmake bootsplash
570 installmake installer
571 installmake initrd
572 }
573
574 buildpackages() {
575 LOGFILE="$BASEDIR/log/_build.packages.log"
576 export LOGFILE
577 echo "... see detailed log in _build.*.log files" >> $LOGFILE
578
579 installmake strip
580
581 # Generating list of packages used
582 echo -n "Generating packages list from logs" | tee -a $LOGFILE
583 rm -f $BASEDIR/doc/packages-list
584 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
585 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
586 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
587 fi
588 done
589 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
590 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$' \
591 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
592 rm -f $BASEDIR/doc/packages-list
593 # packages-list.txt is ready to be displayed for wiki page
594 beautify message DONE
595
596 # Create images for install
597 ipfiremake cdrom
598 ipfiremake pxe
599 cp -f $LFS/install/images/{*.iso,*.tgz} $BASEDIR >> $LOGFILE 2>&1
600
601 # ipfirepackages
602
603 # Cleanup
604 stdumount
605 rm -rf $BASEDIR/build/tmp/*
606
607 # Generating total list of files
608 echo "Generating files list from logs" | tee -a $LOGFILE
609 rm -f $BASEDIR/log/FILES
610 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
611 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
612 echo "##" >>$BASEDIR/log/FILES
613 echo "## `basename $i`" >>$BASEDIR/log/FILES
614 echo "##" >>$BASEDIR/log/FILES
615 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
616 fi
617 done
618 cd $BASEDIR/packages; ls -w1 *.ipfire | awk -F ".ipfire" '{ print $1 }' > $BASEDIR/packages/packages_list.txt
619 echo -n "###EOF###" >> $BASEDIR/packages/packages_list.txt
620
621 cd $PWD
622
623 }
624
625 ipfirepackages() {
626 if [ -d "$BASEDIR/packages" ]; then
627 for i in `ls $BASEDIR/packages`; do
628 touch $BASEDIR/build/install/packages/$i.empty
629 done
630 fi
631 # ipfiredist amavisd
632 ipfiredist applejuice
633 ipfiredist asterisk
634 ipfiredist clamav
635 ipfiredist cups
636 ipfiredist cyrusimap
637 ipfiredist fetchmail
638 ipfiredist ffmpeg
639 ipfiredist gnump3d
640 ipfiredist iptraf
641 ipfiredist java
642 ipfiredist lame
643 ipfiredist libmad
644 ipfiredist libogg
645 ipfiredist libvorbis
646 ipfiredist mailx
647 ipfiredist mldonkey
648 ipfiredist mpeg2dec
649 ipfiredist nagios
650 ipfiredist nfs
651 ipfiredist nmap
652 ipfiredist ntop
653 ipfiredist portmap
654 ipfiredist postfix
655 ipfiredist procmail
656 ipfiredist samba
657 ipfiredist sox
658 ipfiredist spamassassin
659 ipfiredist subversion
660 ipfiredist videolan
661 ipfiredist webcyradm
662 ipfiredist xvid
663 ipfiredist yasuc
664 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
665 mv -f $LFS/install/packages/*.{ipfire,md5} $BASEDIR/packages >> $LOGFILE 2>&1
666 rm -rf $BASEDIR/build/install/packages/*
667 }
668
669 # See what we're supposed to do
670 case "$1" in
671 build)
672 clear
673 BUILDMACHINE=`uname -m`
674 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
675 #only restore on a clean disk
676 if [ ! -f log/cleanup-toolchain-2-tools ]; then
677 if [ ! -n "$PACKAGE" ]; then
678 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
679 prepareenv
680 buildtoolchain
681 else
682 PACKAGENAME=${PACKAGE%.tar.gz}
683 beautify build_stage "Packaged toolchain compilation"
684 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
685 tar zxf $PACKAGE
686 prepareenv
687 else
688 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
689 fi
690 fi
691 else
692 echo -n "Using installed toolchain" | tee -a $LOGFILE
693 beautify message SKIP
694 prepareenv
695 fi
696
697 beautify build_start
698 beautify build_stage_start "Building base"
699 buildbase
700 beautify build_stage_end
701
702 beautify build_stage_start "Building IPFire"
703 buildipfire
704 beautify build_stage_end
705
706 # Setzen des IPFire Builds
707 if [ "$FIREBUILD" ]; then
708 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
709 else
710 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
711 fi
712
713 beautify build_stage_start "Building installer"
714 buildinstaller
715 beautify build_stage_end
716
717 beautify build_stage_start "Building packages"
718 buildpackages
719 beautify build_stage_end
720 beautify build_end
721 ;;
722 shell)
723 # enter a shell inside LFS chroot
724 # may be used to changed kernel settings
725 prepareenv
726 entershell
727 ;;
728 changelog)
729 echo -n "Loading new Changelog from SVN: "
730 svn log http://svn.ipfire.eu/svn/ipfire > doc/ChangeLog
731 beautify message DONE
732 ;;
733 clean)
734 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
735 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
736 $LOSETUP -d $i 2>/dev/null
737 done
738 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
739 umount $i
740 done
741 stdumount
742 for i in `seq 0 7`; do
743 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
744 umount /dev/loop${i} 2>/dev/null;
745 losetup -d /dev/loop${i} 2>/dev/null;
746 fi;
747 done
748 rm -rf $BASEDIR/build
749 rm -rf $BASEDIR/cdrom
750 rm -rf $BASEDIR/packages
751 rm -rf $BASEDIR/log
752 if [ -h /tools ]; then
753 rm -f /tools
754 fi
755 beautify message DONE
756 ;;
757 downloadsrc)
758 if [ ! -d $BASEDIR/cache ]; then
759 mkdir $BASEDIR/cache
760 fi
761 mkdir -p $BASEDIR/log
762 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
763 FINISHED=0
764 cd $BASEDIR/lfs
765 for c in `seq $MAX_RETRIES`; do
766 if (( FINISHED==1 )); then
767 break
768 fi
769 FINISHED=1
770 cd $BASEDIR/lfs
771 for i in *; do
772 if [ -f "$i" -a "$i" != "Config" ]; then
773 echo -ne "Loading $i"
774 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
775 if [ $? -ne 0 ]; then
776 beautify message FAIL
777 FINISHED=0
778 else
779 if [ $c -eq 1 ]; then
780 beautify message DONE
781 fi
782 fi
783 fi
784 done
785 done
786 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
787 ERROR=0
788 for i in *; do
789 if [ -f "$i" -a "$i" != "Config" ]; then
790 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
791 if [ $? -ne 0 ]; then
792 echo -ne "MD5 difference in lfs/$i"
793 beautify message FAIL
794 ERROR=1
795 fi
796 fi
797 done
798 if [ $ERROR -eq 0 ]; then
799 echo -ne "${BOLD}all files md5sum match${NORMAL}"
800 beautify message DONE
801 else
802 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
803 beautify message FAIL
804 fi
805 cd - >/dev/null 2>&1
806 ;;
807 toolchain)
808 clear
809 prepareenv
810 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
811 buildtoolchain
812 BUILDMACHINE=`uname -m`
813 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
814 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
815 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
816 build/{bin,etc,usr/bin,usr/local} \
817 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
818 log >> $LOGFILE
819 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
820 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
821 stdumount
822 ;;
823 gettoolchain)
824 BUILDMACHINE=`uname -m`
825 # arbitrary name to be updated in case of new toolchain package upload
826 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
827 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
828 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
829 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
830 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
831 cd $BASEDIR/cache/toolchains
832 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
833 if [ $? -ne 0 ]; then
834 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
835 else
836 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
837 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
838 else
839 exiterror "$PACKAGE.md5 did not match, check downloaded package"
840 fi
841 fi
842 else
843 echo "Toolchain is already downloaded. Exiting..."
844 fi
845 ;;
846 othersrc)
847 prepareenv
848 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
849 chroot $LFS /tools/bin/env -i HOME=/root \
850 TERM=$TERM PS1='\u:\w\$ ' \
851 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
852 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
853 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
854 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
855 if [ $? -eq "0" ]; then
856 beautify message DONE
857 else
858 beautify message FAIL
859 fi
860 stdumount
861 ;;
862 svn)
863 case "$2" in
864 update|up)
865 # clear
866 echo -ne "Loading the latest source files...\n"
867 if [ $3 ]; then
868 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
869 else
870 svn update | tee -a $PWD/log/_build.svn.update.log
871 fi
872 if [ $? -eq "0" ]; then
873 beautify message DONE
874 else
875 beautify message FAIL
876 exit 1
877 fi
878 echo -ne "Writing the svn-info to a file"
879 svn info > $PWD/svn_status
880 if [ $? -eq "0" ]; then
881 beautify message DONE
882 else
883 beautify message FAIL
884 exit 1
885 fi
886 chmod 755 $0
887 exit 0
888 ;;
889 commit|ci)
890 clear
891 if [ -f /usr/bin/mcedit ]; then
892 export EDITOR=/usr/bin/mcedit
893 fi
894 if [ -f /usr/bin/nano ]; then
895 export EDITOR=/usr/bin/nano
896 fi
897 echo -ne "Selecting editor $EDITOR..."
898 beautify message DONE
899 if [ -e /sbin/yast ]; then
900 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
901 $0 changelog
902 fi
903 fi
904 svn commit
905 $0 svn up
906 $0 uploadsrc
907 ;;
908 dist)
909 if [ $3 ]; then
910 SVN_REVISION=$3
911 fi
912 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
913 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
914 exit 0
915 fi
916 echo -en "REV $SVN_REVISION: Downloading..."
917 svn export http://svn.ipfire.eu/svn/ipfire/trunk ipfire-source/ --force > /dev/null
918 svn log http://svn.ipfire.eu/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
919 #svn info http://svn.ipfire.eu/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
920 evaluate 1
921
922 echo -en "REV $SVN_REVISION: Compressing files..."
923 if [ -e ipfire-source/trunk/make.sh ]; then
924 chmod 755 ipfire-source/trunk/make.sh
925 fi
926 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
927 evaluate 1
928 echo -en "REV $SVN_REVISION: Cleaning up..."
929 rm ipfire-source/ -r
930 evaluate 1
931 ;;
932 diff|di)
933 echo -ne "Make a local diff to last svn revision"
934 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
935 evaluate 1
936 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
937 ;;
938 esac
939 ;;
940 uploadsrc)
941 PWD=`pwd`
942 cd $BASEDIR/cache/
943 echo -e "Uploading cache to ftp server:"
944 ncftpls -u $IPFIRE_FTP_USER_INT -p $IPFIRE_FTP_PASS_INT ftp://$IPFIRE_FTP_URL_INT$IPFIRE_FTP_PATH_INT/ > /var/tmp/ftplist
945 for i in *; do
946 if [ "$i" == "toolchains" ]; then continue; fi
947 grep -q $i /var/tmp/ftplist
948 if [ "$?" -ne "0" ]; then
949 echo -ne "$i"
950 ncftpput -bb -u $IPFIRE_FTP_USER_INT -p $IPFIRE_FTP_PASS_INT $IPFIRE_FTP_URL_INT $IPFIRE_FTP_PATH_INT/ $i >> $BASEDIR/log/_build.uploadsrc.log 2>&1
951 if [ "$?" -eq "0" ]; then
952 beautify message DONE
953 else
954 beautify message FAIL
955 fi
956 fi
957 done
958 rm -f /var/tmp/ftplist
959 UL_TIME_START=`date +'%s'`
960 ncftpbatch -d > /dev/null 2>&1
961 while ps acx | grep -q ncftpbatch
962 do
963 UL_TIME=$(expr `date +'%s'` - $UL_TIME_START)
964 echo -ne "\r ${UL_TIME}s : Upload is running..."
965 sleep 1
966 done
967 beautify message DONE
968 cd $PWD
969 exit 0
970 ;;
971 upload)
972 case "$2" in
973 iso)
974 echo -e "Uploading the iso to $IPFIRE_FTP_URL_EXT."
975 cat <<EOF > .ftp-commands
976 mkdir $IPFIRE_FTP_PATH_EXT
977 ls -lah
978 quit
979 EOF
980 ncftp -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT < .ftp-commands
981 rm -f .ftp-commands
982 md5sum ipfire-install-$VERSION.i386.iso > ipfire-install-$VERSION.i386.iso.md5
983 ncftpput -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT $IPFIRE_FTP_PATH_EXT/ ipfire-install-$VERSION.i386.iso
984 ncftpput -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT $IPFIRE_FTP_PATH_EXT/ ipfire-install-$VERSION.i386.iso.md5
985 ncftpput -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT $IPFIRE_FTP_PATH_EXT/ ipfire-source-r$SVN_REVISION.tar.gz
986 ncftpput -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT $IPFIRE_FTP_PATH_EXT/ svn_status
987 if [ "$?" -eq "0" ]; then
988 echo -e "The iso of Revision $SVN_REVISION was successfully uploaded to $IPFIRE_FTP_URL_EXT$IPFIRE_FTP_PATH_EXT/."
989 else
990 echo -e "There was an error while uploading the iso to the ftp server."
991 exit 1
992 fi
993 if [ "$3" = "--with-sources-cd" ]; then
994 ncftpput -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT $IPFIRE_FTP_PATH_EXT/ ipfire-sources-cd-$VERSION.$MACHINE.iso
995 fi
996 ;;
997 paks)
998 cat <<EOF > .ftp-commands
999 mkdir $IPFIRE_FTP_PATH_PAK
1000 ls -lah
1001 quit
1002 EOF
1003 ncftp -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK < .ftp-commands
1004 rm -f .ftp-commands
1005 ncftpput -z -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK $IPFIRE_FTP_PATH_PAK/ packages/*
1006 if [ "$?" -eq "0" ]; then
1007 echo -e "The packages were successfully uploaded to $IPFIRE_FTP_URL_PAK$IPFIRE_FTP_PATH_PAK/."
1008 else
1009 echo -e "There was an error while uploading the packages to the ftp server."
1010 exit 1
1011 fi
1012 ;;
1013 esac
1014 ;;
1015 batch)
1016 if [ "$2" -eq "--background" ]; then
1017 batch_script
1018 exit $?
1019 fi
1020 if [ `screen -ls | grep -q ipfire` ]; then
1021 echo "Build is already running, sorry!"
1022 exit 1
1023 else
1024 if [ "$2" = "--rebuild" ]; then
1025 export IPFIRE_REBUILD=1
1026 echo "REBUILD!"
1027 else
1028 export IPFIRE_REBUILD=0
1029 fi
1030 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1031 screen -dmS ipfire $0 batch --background
1032 evaluate 1
1033 exit 0
1034 fi
1035 ;;
1036 watch)
1037 watch_screen
1038 ;;
1039 pxe)
1040 case "$2" in
1041 start)
1042 start_tftpd
1043 ;;
1044 stop)
1045 stop_tftpd
1046 ;;
1047 reload|restart)
1048 reload_tftpd
1049 ;;
1050 esac
1051 exit 0
1052 ;;
1053 "")
1054 clear
1055 svn info
1056 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
1057 do
1058 case $name in
1059 "IPFIRE: Downloadsrc")
1060 $0 downloadsrc
1061 ;;
1062 "IPFIRE: Build (silent)")
1063 $0 build-silent
1064 ;;
1065 "IPFIRE: Watch Build")
1066 $0 watch
1067 ;;
1068 "IPFIRE: Batch")
1069 $0 batch
1070 ;;
1071 "IPFIRE: Clean")
1072 $0 clean
1073 ;;
1074 "SVN: Update")
1075 $0 svn update
1076 ;;
1077 "Help")
1078 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1079 cat doc/make.sh-usage
1080 ;;
1081 "LOG: Tail")
1082 tail -f log/_*
1083 ;;
1084 "Exit")
1085 break
1086 ;;
1087 esac
1088 done
1089 ;;
1090 config)
1091 make_config
1092 ;;
1093 *)
1094 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1095 cat doc/make.sh-usage
1096 ;;
1097 esac